=== modified file 'src/seat.c'
--- src/seat.c	2013-07-21 09:49:29 +0000
+++ src/seat.c	2013-07-22 02:52:22 +0000
@@ -967,10 +967,13 @@
     session_set_argv (SESSION (greeter_session), argv);
 
     greeter_set_pam_services (greeter_session, USER_SERVICE, AUTOLOGIN_SERVICE);
-    greeter_set_allow_guest (greeter_session, seat_get_allow_guest (seat));
     g_signal_connect (greeter_session, "create-session", G_CALLBACK (greeter_create_session_cb), seat);
     g_signal_connect (greeter_session, "start-session", G_CALLBACK (greeter_start_session_cb), seat);
 
+    /* Set hints to greeter */
+    greeter_set_hint (greeter_session, "default-session", seat_get_string_property (seat, "user-session"));
+    greeter_set_allow_guest (greeter_session, seat_get_allow_guest (seat));
+
     return greeter_session;
 }
 

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2013-07-21 08:47:01 +0000
+++ tests/Makefile.am	2013-07-22 02:52:22 +0000
@@ -6,6 +6,7 @@
 	test-greeter-not-installed \
 	test-greeter-xserver-crash \
 	test-greeter-wrapper \
+	test-greeter-default-session \
 	test-no-config \
 	test-additional-config \
 	test-headless \
@@ -286,6 +287,7 @@
 	scripts/dbus.conf \    
 	scripts/denied.conf \
 	scripts/expired.conf \
+	scripts/greeter-default-session.conf \
 	scripts/greeter-fail-start.conf \
 	scripts/greeter-not-installed.conf \
 	scripts/greeter-wrapper.conf \

=== modified file 'tests/src/test-gobject-greeter.c'
--- tests/src/test-gobject-greeter.c	2013-07-20 10:46:48 +0000
+++ tests/src/test-gobject-greeter.c	2013-07-22 02:52:22 +0000
@@ -129,6 +129,11 @@
     }
     g_free (r);
 
+    r = g_strdup_printf ("%s LOG-DEFAULT-SESSION", greeter_id);
+    if (strcmp (request, r) == 0)
+        status_notify ("%s LOG-DEFAULT-SESSION SESSION=%s", greeter_id, lightdm_greeter_get_default_session_hint (greeter));
+    g_free (r);
+
     r = g_strdup_printf ("%s LOG-USER-LIST-LENGTH", greeter_id);
     if (strcmp (request, r) == 0)
         status_notify ("%s LOG-USER-LIST-LENGTH N=%d", greeter_id, lightdm_user_list_get_length (lightdm_user_list_get_instance ()));

=== added file 'tests/test-greeter-default-session'
--- tests/test-greeter-default-session	1970-01-01 00:00:00 +0000
+++ tests/test-greeter-default-session	2013-07-22 02:52:22 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+./src/dbus-env ./src/test-runner greeter-default-session test-gobject-greeter

